/*
 * WinDom: a high level GEM library
 * Copyright (c) 1997-2003 Dominique Bereziat & Arnaud Bercegeay
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 * $Source: /cvsroot/windom/windom/src/evnt_redraw.c,v $
 *
 * CVS info:
 *   $Author: bercegeay $
 *   $Date: 2004/11/02 20:44:51 $
 *   $Revision: 1.2 $
 */


#include <stdio.h>
#include <stdlib.h>
#include "globals.h"

/*
 * L'vnement WM_REDRAW est le seul vnement qui ne peut 
 * pas etre appel directement par EvntExec() (parcequ'il
 * faut le masquer).
 */

void EvntRedraw( WINDOW *win) {
	GRECT work, rect, screen;
	
	while( !wind_update(BEG_UPDATE));
	graf_mouse( M_OFF, 0L);
	WindGet( win, WF_WORKXYWH, &work.g_x, &work.g_y, &work.g_w, &work.g_h);
	wind_get_grect( 0, WF_CURRXYWH, &screen);
	wind_get_grect( win->handle, WF_FIRSTXYWH, &rect);
	while( rect.g_w && rect.g_h) {
		if ( rc_intersect( &work, &rect) && rc_intersect( &screen, &rect)) {
			rc_clip_on( win->graf.handle, &rect);
			EvntExec( win, WM_REDRAW);
			rc_clip_off( win->graf.handle);
		}
		wind_get_grect( win->handle, WF_NEXTXYWH, &rect);
	}
	graf_mouse( M_ON, 0L);
	wind_update(END_UPDATE);
}
